#include "AIZ/AIZEggRobo.c"
#include "AIZ/AIZEncoreTutorial.c"
#include "AIZ/AIZKingClaw.c"
#include "AIZ/AIZRockPile.c"
#include "AIZ/AIZSetup.c"
#include "AIZ/AIZTornado.c"
#include "AIZ/AIZTornadoPath.c"
#include "AIZ/Bloominator.c"
#include "AIZ/EncoreIntro.c"
#include "AIZ/FernParallax.c"
#include "AIZ/MonkeyDude.c"
#include "AIZ/Rhinobot.c"
#include "AIZ/SchrodingersCapsule.c"
#include "AIZ/Sweep.c"
#include "BSS/BSS_Collectable.c"
#include "BSS/BSS_Collected.c"
#include "BSS/BSS_HUD.c"
#include "BSS/BSS_Horizon.c"
#include "BSS/BSS_Message.c"
#include "BSS/BSS_Palette.c"
#include "BSS/BSS_Player.c"
#include "BSS/BSS_Setup.c"
#include "CPZ/AmoebaDroid.c"
#include "CPZ/Ball.c"
#include "CPZ/Bubbler.c"
#include "CPZ/CPZ1Intro.c"
#include "CPZ/CPZ2Outro.c"
#include "CPZ/CPZBoss.c"
#include "CPZ/CPZSetup.c"
#include "CPZ/CPZShutter.c"
#include "CPZ/CaterkillerJr.c"
#include "CPZ/ChemBubble.c"
#include "CPZ/ChemicalBall.c"
#include "CPZ/ChemicalPool.c"
#include "CPZ/DNARiser.c"
#include "CPZ/Grabber.c"
#include "CPZ/OneWayDoor.c"
#include "CPZ/Reagent.c"
#include "CPZ/RotatingStair.c"
#include "CPZ/SpeedBooster.c"
#include "CPZ/Spiny.c"
#include "CPZ/Springboard.c"
#include "CPZ/Staircase.c"
#include "CPZ/StickyPlatform.c"
#include "CPZ/Syringe.c"
#include "CPZ/TippingPlatform.c"
#include "CPZ/TransportTube.c"
#include "CPZ/TubeSpring.c"
#include "CPZ/TwistedTubes.c"
#include "Common/BGSwitch.c"
#include "Common/BreakableWall.c"
#include "Common/Button.c"
#include "Common/CollapsingPlatform.c"
#include "Common/Decoration.c"
#include "Common/Eggman.c"
#include "Common/FlingRamp.c"
#include "Common/ForceSpin.c"
#include "Common/ForceUnstick.c"
#include "Common/GenericTrigger.c"
#include "Common/Palette.c"
#include "Common/ParallaxSprite.c"
#include "Common/Platform.c"
#include "Common/PlatformControl.c"
#include "Common/PlatformNode.c"
#include "Common/Projectile.c"
#include "Common/SpinBooster.c"
#include "Common/TilePlatform.c"
#include "Common/Water.c"
#include "Continue/ContinuePlayer.c"
#include "Continue/ContinueSetup.c"
#include "Credits/AnimalHBH.c"
#include "Credits/CreditsSetup.c"
#include "Credits/EncoreGoodEnd.c"
#include "Credits/TAEmerald.c"
#include "Credits/TryAgain.c"
#include "Credits/TryAgainE.c"
#include "Cutscene/ChaosEmerald.c"
#include "Cutscene/CutsceneHBH.c"
#include "Cutscene/CutsceneRules.c"
#include "Cutscene/CutsceneSeq.c"
#include "Cutscene/FXExpandRing.c"
#include "Cutscene/FXFade.c"
#include "Cutscene/FXRuby.c"
#include "Cutscene/FXSpinRay.c"
#include "Cutscene/FXTrail.c"
#include "Cutscene/FXWaveRing.c"
#include "Cutscene/RubyPortal.c"
#include "ERZ/ERZGunner.c"
#include "ERZ/ERZKing.c"
#include "ERZ/ERZMystic.c"
#include "ERZ/ERZOutro.c"
#include "ERZ/ERZRider.c"
#include "ERZ/ERZSetup.c"
#include "ERZ/ERZShinobi.c"
#include "ERZ/ERZStart.c"
#include "ERZ/KleptoMobile.c"
#include "ERZ/PKingAttack.c"
#include "ERZ/PhantomEgg.c"
#include "ERZ/PhantomGunner.c"
#include "ERZ/PhantomHand.c"
#include "ERZ/PhantomKing.c"
#include "ERZ/PhantomMissile.c"
#include "ERZ/PhantomMystic.c"
#include "ERZ/PhantomRider.c"
#include "ERZ/PhantomRuby.c"
#include "ERZ/PhantomShield.c"
#include "ERZ/PhantomShinobi.c"
#include "ERZ/RingField.c"
#include "FBZ/BigSqueeze.c"
#include "FBZ/Blaster.c"
#include "FBZ/Clucker.c"
#include "FBZ/Crane.c"
#include "FBZ/Cylinder.c"
#include "FBZ/ElectroMagnet.c"
#include "FBZ/FBZ1Outro.c"
#include "FBZ/FBZ2Outro.c"
#include "FBZ/FBZFan.c"
#include "FBZ/FBZMissile.c"
#include "FBZ/FBZSetup.c"
#include "FBZ/FBZSinkTrash.c"
#include "FBZ/FBZStorm.c"
#include "FBZ/FBZTrash.c"
#include "FBZ/FlameSpring.c"
#include "FBZ/FoldingPlatform.c"
#include "FBZ/HangGlider.c"
#include "FBZ/HangPoint.c"
#include "FBZ/Launcher.c"
#include "FBZ/LightBarrier.c"
#include "FBZ/MagPlatform.c"
#include "FBZ/MagSpikeBall.c"
#include "FBZ/Mine.c"
#include "FBZ/Propeller.c"
#include "FBZ/PropellerShaft.c"
#include "FBZ/SpiderMobile.c"
#include "FBZ/SpiralPlatform.c"
#include "FBZ/SwitchDoor.c"
#include "FBZ/Technosqueek.c"
#include "FBZ/TetherBall.c"
#include "FBZ/Tuesday.c"
#include "FBZ/TwistingDoor.c"
#include "FBZ/WarpDoor.c"
#include "GHZ/Batbrain.c"
#include "GHZ/Bridge.c"
#include "GHZ/BurningLog.c"
#include "GHZ/BuzzBomber.c"
#include "GHZ/CheckerBall.c"
#include "GHZ/Chopper.c"
#include "GHZ/CorkscrewPath.c"
#include "GHZ/Crabmeat.c"
#include "GHZ/DDWrecker.c"
#include "GHZ/DERobot.c"
#include "GHZ/Fireball.c"
#include "GHZ/GHZ2Outro.c"
#include "GHZ/GHZCutsceneK.c"
#include "GHZ/GHZCutsceneST.c"
#include "GHZ/GHZSetup.c"
#include "GHZ/Motobug.c"
#include "GHZ/Newtron.c"
#include "GHZ/SpikeLog.c"
#include "GHZ/Splats.c"
#include "GHZ/WaterfallSound.c"
#include "GHZ/ZipLine.c"
#include "Global/APICallback.c"
#include "Global/ActClear.c"
#include "Global/Animals.c"
#include "Global/Announcer.c"
#include "Global/BoundsMarker.c"
#include "Global/COverlay.c"
#include "Global/Camera.c"
#include "Global/Competition.c"
#include "Global/Debris.c"
#include "Global/DebugMode.c"
#include "Global/DialogRunner.c"
#include "Global/Dust.c"
#include "Global/EggPrison.c"
#include "Global/EncoreRoute.c"
#include "Global/Explosion.c"
#include "Global/GameOver.c"
#include "Global/HUD.c"
#include "Global/ImageTrail.c"
#include "Global/InvincibleStars.c"
#include "Global/InvisibleBlock.c"
#include "Global/ItemBox.c"
#include "Global/Localization.c"
#include "Global/Music.c"
#include "Global/NoSwap.c"
#include "Global/PauseMenu.c"
#include "Global/PlaneSwitch.c"
#include "Global/Player.c"
#include "Global/ReplayRecorder.c"
#include "Global/Ring.c"
#include "Global/SaveGame.c"
#include "Global/ScoreBonus.c"
#include "Global/Shield.c"
#include "Global/SignPost.c"
#include "Global/Soundboard.c"
#include "Global/SpecialRing.c"
#include "Global/SpeedGate.c"
#include "Global/Spikes.c"
#include "Global/Spring.c"
#include "Global/StarPost.c"
#include "Global/SuperSparkle.c"
#include "Global/TimeAttackGate.c"
#include "Global/TitleCard.c"
#include "Global/Zone.c"
#include "HCZ/Blastoid.c"
#include "HCZ/BreakBar.c"
#include "HCZ/Buggernaut.c"
#include "HCZ/ButtonDoor.c"
#include "HCZ/Current.c"
#include "HCZ/DCEvent.c"
#include "HCZ/DiveEggman.c"
#include "HCZ/Fan.c"
#include "HCZ/Gondola.c"
#include "HCZ/HCZ1Intro.c"
#include "HCZ/HCZOneWayDoor.c"
#include "HCZ/HCZSetup.c"
#include "HCZ/HCZSpikeBall.c"
#include "HCZ/HandLauncher.c"
#include "HCZ/HangConveyor.c"
#include "HCZ/Jawz.c"
#include "HCZ/Jellygnite.c"
#include "HCZ/LaundroMobile.c"
#include "HCZ/MegaChopper.c"
#include "HCZ/Pointdexter.c"
#include "HCZ/PullChain.c"
#include "HCZ/ScrewMobile.c"
#include "HCZ/Spear.c"
#include "HCZ/TurboSpiker.c"
#include "HCZ/TwistingSlide.c"
#include "HCZ/WaterGush.c"
#include "HCZ/Whirlpool.c"
#include "HPZ/Batbot.c"
#include "HPZ/Redz.c"
#include "HPZ/Stegway.c"
#include "Helpers/BadnikHelpers.c"
#include "Helpers/ColorHelpers.c"
#include "Helpers/CompetitionSession.c"
#include "Helpers/DrawHelpers.c"
#include "Helpers/GameProgress.c"
#include "Helpers/LogHelpers.c"
#include "Helpers/MathHelpers.c"
#include "Helpers/Options.c"
#include "Helpers/ParticleHelpers.c"
#include "Helpers/PlayerHelpers.c"
#include "Helpers/PlayerProbe.c"
#include "Helpers/ReplayDB.c"
#include "Helpers/TimeAttackData.c"
#include "LRZ/BuckwildBall.c"
#include "LRZ/DashLift.c"
#include "LRZ/Drillerdroid.c"
#include "LRZ/DrillerdroidO.c"
#include "LRZ/Fireworm.c"
#include "LRZ/Flamethrower.c"
#include "LRZ/HPZEmerald.c"
#include "LRZ/HeavyKing.c"
#include "LRZ/HeavyRider.c"
#include "LRZ/Iwamodoki.c"
#include "LRZ/KingAttack.c"
#include "LRZ/KingClaw.c"
#include "LRZ/LRZ1Intro.c"
#include "LRZ/LRZ1Outro.c"
#include "LRZ/LRZ1Setup.c"
#include "LRZ/LRZ2Setup.c"
#include "LRZ/LRZ3Cutscene.c"
#include "LRZ/LRZ3Outro.c"
#include "LRZ/LRZ3OutroK.c"
#include "LRZ/LRZ3Setup.c"
#include "LRZ/LRZConvControl.c"
#include "LRZ/LRZConvDropper.c"
#include "LRZ/LRZConvItem.c"
#include "LRZ/LRZConvSwitch.c"
#include "LRZ/LRZConveyor.c"
#include "LRZ/LRZFireball.c"
#include "LRZ/LRZRockPile.c"
#include "LRZ/LRZSpikeBall.c"
#include "LRZ/LRZSpiral.c"
#include "LRZ/LavaFall.c"
#include "LRZ/LavaGeyser.c"
#include "LRZ/OrbitSpike.c"
#include "LRZ/Rexon.c"
#include "LRZ/RisingLava.c"
#include "LRZ/RockDrill.c"
#include "LRZ/SkyTeleporter.c"
#include "LRZ/SpikeCrusher.c"
#include "LRZ/Stalactite.c"
#include "LRZ/ThoughtBubble.c"
#include "LRZ/Toxomister.c"
#include "LRZ/Turbine.c"
#include "LRZ/TurretSwitch.c"
#include "LRZ/WalkerLegs.c"
#include "MMZ/BladePole.c"
#include "MMZ/BuzzSaw.c"
#include "MMZ/ConveyorBelt.c"
#include "MMZ/ConveyorPlatform.c"
#include "MMZ/ConveyorWheel.c"
#include "MMZ/EggPistonsMKII.c"
#include "MMZ/FarPlane.c"
#include "MMZ/Gachapandora.c"
#include "MMZ/MMZ2Outro.c"
#include "MMZ/MMZLightning.c"
#include "MMZ/MMZSetup.c"
#include "MMZ/MMZWheel.c"
#include "MMZ/MatryoshkaBom.c"
#include "MMZ/MechaBu.c"
#include "MMZ/Piston.c"
#include "MMZ/PlaneSeeSaw.c"
#include "MMZ/PohBee.c"
#include "MMZ/RPlaneShifter.c"
#include "MMZ/Scarab.c"
#include "MMZ/SizeLaser.c"
#include "MMZ/SpikeCorridor.c"
#include "MMZ/VanishPlatform.c"
#include "MSZ/Armadiloid.c"
#include "MSZ/BarStool.c"
#include "MSZ/Bumpalo.c"
#include "MSZ/Cactula.c"
#include "MSZ/CollapsingSand.c"
#include "MSZ/DBTower.c"
#include "MSZ/EggLoco.c"
#include "MSZ/Flipper.c"
#include "MSZ/GiantPistol.c"
#include "MSZ/Hatterkiller.c"
#include "MSZ/HeavyMystic.c"
#include "MSZ/Honkytonk.c"
#include "MSZ/LightBulb.c"
#include "MSZ/LocoSmoke.c"
#include "MSZ/MSZ1KIntro.c"
#include "MSZ/MSZ2Cutscene.c"
#include "MSZ/MSZCutsceneK.c"
#include "MSZ/MSZCutsceneST.c"
#include "MSZ/MSZSetup.c"
#include "MSZ/MSZSpotlight.c"
#include "MSZ/PaintingEyes.c"
#include "MSZ/Pinata.c"
#include "MSZ/Rattlekiller.c"
#include "MSZ/RollerMKII.c"
#include "MSZ/RotatingSpikes.c"
#include "MSZ/SeeSaw.c"
#include "MSZ/SeltzerBottle.c"
#include "MSZ/SeltzerWater.c"
#include "MSZ/SideBarrel.c"
#include "MSZ/SwingRope.c"
#include "MSZ/Tornado.c"
#include "MSZ/TornadoPath.c"
#include "MSZ/UberCaterkiller.c"
#include "MSZ/Vultron.c"
#include "Menu/CompetitionMenu.c"
#include "Menu/DAControl.c"
#include "Menu/DASetup.c"
#include "Menu/DemoMenu.c"
#include "Menu/E3MenuSetup.c"
#include "Menu/ExtrasMenu.c"
#include "Menu/LevelSelect.c"
#include "Menu/LogoSetup.c"
#include "Menu/MainMenu.c"
#include "Menu/ManiaModeMenu.c"
#include "Menu/MenuParam.c"
#include "Menu/MenuSetup.c"
#include "Menu/OptionsMenu.c"
#include "Menu/ThanksSetup.c"
#include "Menu/TimeAttackMenu.c"
#include "Menu/UIBackground.c"
#include "Menu/UIButton.c"
#include "Menu/UIButtonLabel.c"
#include "Menu/UIButtonPrompt.c"
#include "Menu/UICarousel.c"
#include "Menu/UICharButton.c"
#include "Menu/UIChoice.c"
#include "Menu/UIControl.c"
#include "Menu/UICreditsText.c"
#include "Menu/UIDialog.c"
#include "Menu/UIDiorama.c"
#include "Menu/UIHeading.c"
#include "Menu/UIInfoLabel.c"
#include "Menu/UIKeyBinder.c"
#include "Menu/UILeaderboard.c"
#include "Menu/UIMedallionPanel.c"
#include "Menu/UIModeButton.c"
#include "Menu/UIOptionPanel.c"
#include "Menu/UIPicture.c"
#include "Menu/UIPopover.c"
#include "Menu/UIRankButton.c"
#include "Menu/UIReplayCarousel.c"
#include "Menu/UIResPicker.c"
#include "Menu/UISaveSlot.c"
#include "Menu/UIShifter.c"
#include "Menu/UISlider.c"
#include "Menu/UISubHeading.c"
#include "Menu/UITABanner.c"
#include "Menu/UITAZoneModule.c"
#include "Menu/UIText.c"
#include "Menu/UITransition.c"
#include "Menu/UIUsernamePopup.c"
#include "Menu/UIVideo.c"
#include "Menu/UIVsCharSelector.c"
#include "Menu/UIVsResults.c"
#include "Menu/UIVsRoundPicker.c"
#include "Menu/UIVsScoreboard.c"
#include "Menu/UIVsZoneButton.c"
#include "Menu/UIWaitSpinner.c"
#include "Menu/UIWidgets.c"
#include "Menu/UIWinSize.c"
#include "OOZ/Aquis.c"
#include "OOZ/BallCannon.c"
#include "OOZ/GasPlatform.c"
#include "OOZ/Hatch.c"
#include "OOZ/MegaOctus.c"
#include "OOZ/MeterDroid.c"
#include "OOZ/OOZ1Outro.c"
#include "OOZ/OOZ2Outro.c"
#include "OOZ/OOZFlames.c"
#include "OOZ/OOZSetup.c"
#include "OOZ/Octus.c"
#include "OOZ/PullSwitch.c"
#include "OOZ/PushSpring.c"
#include "OOZ/Smog.c"
#include "OOZ/Sol.c"
#include "OOZ/Valve.c"
#include "PGZ/Acetone.c"
#include "PGZ/Crate.c"
#include "PGZ/DoorTrigger.c"
#include "PGZ/Dragonfly.c"
#include "PGZ/FrostThrower.c"
#include "PGZ/HeavyShinobi.c"
#include "PGZ/Ice.c"
#include "PGZ/IceBomba.c"
#include "PGZ/IceSpring.c"
#include "PGZ/Ink.c"
#include "PGZ/InkWipe.c"
#include "PGZ/JuggleSaw.c"
#include "PGZ/Newspaper.c"
#include "PGZ/PSZ1Intro.c"
#include "PGZ/PSZ1Setup.c"
#include "PGZ/PSZ2Intro.c"
#include "PGZ/PSZ2Outro.c"
#include "PGZ/PSZ2Setup.c"
#include "PGZ/PSZDoor.c"
#include "PGZ/PSZEggman.c"
#include "PGZ/PSZLauncher.c"
#include "PGZ/PaperRoller.c"
#include "PGZ/PetalPile.c"
#include "PGZ/Press.c"
#include "PGZ/PrintBlock.c"
#include "PGZ/SP500.c"
#include "PGZ/SP500MkII.c"
#include "PGZ/Shiversaw.c"
#include "PGZ/Shuriken.c"
#include "PGZ/Snowflakes.c"
#include "PGZ/Turntable.c"
#include "PGZ/WoodChipper.c"
#include "PGZ/Woodrow.c"
#include "Pinball/PBL_Bumper.c"
#include "Pinball/PBL_Camera.c"
#include "Pinball/PBL_Crane.c"
#include "Pinball/PBL_Flipper.c"
#include "Pinball/PBL_HUD.c"
#include "Pinball/PBL_Player.c"
#include "Pinball/PBL_Ring.c"
#include "Pinball/PBL_Sector.c"
#include "Pinball/PBL_Setup.c"
#include "Pinball/PBL_TargetBumper.c"
#include "Puyo/PuyoAI.c"
#include "Puyo/PuyoAttack.c"
#include "Puyo/PuyoBean.c"
#include "Puyo/PuyoGame.c"
#include "Puyo/PuyoIndicator.c"
#include "Puyo/PuyoLabel.c"
#include "Puyo/PuyoLevelSelect.c"
#include "Puyo/PuyoMatch.c"
#include "Puyo/PuyoScore.c"
#include "SBZ/Bomb.c"
#include "SBZ/Caterkiller.c"
#include "SBZ/Orbinaut.c"
#include "SPZ/CableWarp.c"
#include "SPZ/Canista.c"
#include "SPZ/CircleBumper.c"
#include "SPZ/Clapperboard.c"
#include "SPZ/DirectorChair.c"
#include "SPZ/EggJanken.c"
#include "SPZ/EggJankenPart.c"
#include "SPZ/EggTV.c"
#include "SPZ/FilmProjector.c"
#include "SPZ/FilmReel.c"
#include "SPZ/Funnel.c"
#include "SPZ/GreenScreen.c"
#include "SPZ/HeavyGunner.c"
#include "SPZ/LEDPanel.c"
#include "SPZ/Letterboard.c"
#include "SPZ/LottoBall.c"
#include "SPZ/LottoMachine.c"
#include "SPZ/LoveTester.c"
#include "SPZ/MicDrop.c"
#include "SPZ/PathInverter.c"
#include "SPZ/PimPom.c"
#include "SPZ/PopcornKernel.c"
#include "SPZ/PopcornMachine.c"
#include "SPZ/RockemSockem.c"
#include "SPZ/SPZ1Intro.c"
#include "SPZ/SPZ1Setup.c"
#include "SPZ/SPZ2Outro.c"
#include "SPZ/SPZ2Setup.c"
#include "SPZ/ShopWindow.c"
#include "SPZ/Shutterbug.c"
#include "SPZ/SpinSign.c"
#include "SPZ/TVFlyingBattery.c"
#include "SPZ/TVPole.c"
#include "SPZ/TVVan.c"
#include "SPZ/Tubinaut.c"
#include "SPZ/WeatherMobile.c"
#include "SPZ/WeatherTV.c"
#include "SSZ/Beanstalk.c"
#include "SSZ/BouncePlant.c"
#include "SSZ/Bungee.c"
#include "SSZ/Constellation.c"
#include "SSZ/Dango.c"
#include "SSZ/EggTower.c"
#include "SSZ/Fireflies.c"
#include "SSZ/Firework.c"
#include "SSZ/FlowerPod.c"
#include "SSZ/GigaMetal.c"
#include "SSZ/HiLoSign.c"
#include "SSZ/Hotaru.c"
#include "SSZ/HotaruHiWatt.c"
#include "SSZ/HotaruMKII.c"
#include "SSZ/JunctionWheel.c"
#include "SSZ/Kabasira.c"
#include "SSZ/Kanabun.c"
#include "SSZ/MSBomb.c"
#include "SSZ/MSFactory.c"
#include "SSZ/MSHologram.c"
#include "SSZ/MSOrb.c"
#include "SSZ/MSPanel.c"
#include "SSZ/MetalSonic.c"
#include "SSZ/MonarchPlans.c"
#include "SSZ/RTeleporter.c"
#include "SSZ/SDashWheel.c"
#include "SSZ/SSZ1Intro.c"
#include "SSZ/SSZ1Outro.c"
#include "SSZ/SSZ1Setup.c"
#include "SSZ/SSZ2Setup.c"
#include "SSZ/SSZ3Cutscene.c"
#include "SSZ/SSZEggman.c"
#include "SSZ/SSZSpikeBall.c"
#include "SSZ/SSZSpotlight.c"
#include "SSZ/SilverSonic.c"
#include "SSZ/SparkRail.c"
#include "SSZ/SpikeFlail.c"
#include "SSZ/TTCutscene.c"
#include "SSZ/TimePost.c"
#include "SSZ/TimeTravelSetup.c"
#include "SSZ/UncurlPlant.c"
#include "SSZ/YoyoPulley.c"
#include "Summary/Summary.c"
#include "Summary/SummaryEmerald.c"
#include "TMZ/BallHog.c"
#include "TMZ/CrashTest.c"
#include "TMZ/CrimsonEye.c"
#include "TMZ/EscapeCar.c"
#include "TMZ/FlasherMKII.c"
#include "TMZ/GymBar.c"
#include "TMZ/JacobsLadder.c"
#include "TMZ/LargeGear.c"
#include "TMZ/LaunchSpring.c"
#include "TMZ/MagnetSphere.c"
#include "TMZ/MetalArm.c"
#include "TMZ/MonarchBG.c"
#include "TMZ/PopOut.c"
#include "TMZ/SentryBug.c"
#include "TMZ/TMZ1Outro.c"
#include "TMZ/TMZ1Setup.c"
#include "TMZ/TMZ2Outro.c"
#include "TMZ/TMZ2Setup.c"
#include "TMZ/TMZ3Setup.c"
#include "TMZ/TMZAlert.c"
#include "TMZ/TMZBarrier.c"
#include "TMZ/TMZCable.c"
#include "TMZ/TMZFlames.c"
#include "TMZ/TeeterTotter.c"
#include "TMZ/TurboTurtle.c"
#include "TMZ/WallBumper.c"
#include "Title/Title3DSprite.c"
#include "Title/TitleBG.c"
#include "Title/TitleEggman.c"
#include "Title/TitleLogo.c"
#include "Title/TitleSetup.c"
#include "Title/TitleSonic.c"
#include "UFO/SpecialClear.c"
#include "UFO/UFO_Camera.c"
#include "UFO/UFO_Circuit.c"
#include "UFO/UFO_Decoration.c"
#include "UFO/UFO_Dust.c"
#include "UFO/UFO_HUD.c"
#include "UFO/UFO_ItemBox.c"
#include "UFO/UFO_Message.c"
#include "UFO/UFO_Plasma.c"
#include "UFO/UFO_Player.c"
#include "UFO/UFO_Ring.c"
#include "UFO/UFO_Setup.c"
#include "UFO/UFO_Shadow.c"
#include "UFO/UFO_SpeedLines.c"
#include "UFO/UFO_Sphere.c"
#include "UFO/UFO_Springboard.c"
#include "UFO/UFO_Water.c"
#include "Unused/Pendulum.c"
#include "Unused/SpearBlock.c"
#include "Unused/TargetBumper.c"
#include "Unused/WallCrawl.c"
#include "Unused/Wisp.c"